//////
// Challenge Helper
// by Achoo (12724)
//////
// Uses Event_SpeedRun by ottosparks
// http://forum.blockland.us/index.php?topic=239881.0
//
// and Server_GoTo by jes00
// http://forum.blockland.us/index.php?topic=243057.0
//
// both modified to be compatible
//////
// A quick note on these modifications:
// I made slight changes to how a lot of the functions work, including:
// serverCmdGoTo, loadUnlockedLevels, saveUnlockedLevels, and levelUnlock.
// (Speedrun shit)  (Changing of where stuff is stored)     (Remove message)
// Doing these changes required me (to my knowledge) to copy the entire function.
// If you know how to do the same edits without this, TELL ME. Please! I would love to know.
//////

//////
// Force Required Add-Ons
//////

//If Event_SpeedRun and Server_GoTo aren't here, this won't work.
if(!isFile("Add-Ons/Event_SpeedRun/server.cs") || !isFile("Add-Ons/Server_GoTo/server.cs"))
	return;

//////
// Server Control
//////

// Allows for compatibility with people who have yet to update to Glass.
// I personally use either one depending on the timing, and even oRBs occasionally.
if($RTB::RTBR_ServerControl_Hook || $BLPrefs::Version !$= "")
{
	RTB_registerPref("Challenge Name", "Challenge", "$ChallengeName","string 200","Server_Challenge","_default",0,1,"onChangeInChallengeName");
	RTB_registerPref("Level Count","Challenge","$LevelCount","int 0 99999","Server_Challenge",30,0,1);
	RTB_registerPref("Liquid Kills","Challenge","$KillOnEnterLiquid","bool","Server_Challenge",1,0,0);
	RTB_registerPref("Save Unlocked Levels","Challenge","$GoTo::SaveUnlockedlevels","bool","Server_Challenge",1,0,1);
	//RTB_registerPref("Lessen Suicide Delay","Challenge","$LessenSuicide","bool","Server_Challenge",1,0,0);
	RTB_registerPref("Enable Level Tags","Challenge","$EnableLevelTags","bool","Server_Challenge",1,0,0,"doTagsForEverybody");
	//disabled color changing because it wasn't working
	//really i have no idea how to do it, and it's minor.
	//RTB_registerPref("Tag Color 1","Challenge","$LevelTag[0]","int 0 8","Server_Challenge","5",0,0,"doTagsForEverybody");
	//RTB_registerPref("Tag Color 2","Challenge","$LevelTag[1]","int 0 8","Server_Challenge","4",0,0,"doTagsForEverybody");
	//RTB_registerPref("Tag Color 3","Challenge","$LevelTag[2]","int 0 8","Server_Challenge","2",0,0,"doTagsForEverybody");
	//RTB_registerPref("Tag Color 4","Challenge","$LevelTag[3]","int 0 8","Server_Challenge","3",0,0,"doTagsForEverybody");
	//RTB_registerPref("Tag Color 5","Challenge","$LevelTag[4]","int 0 8","Server_Challenge","6",0,0,"doTagsForEverybody");
	//RTB_registerPref("Tag Color 6","Challenge","$LevelTag[5]","int 0 8","Server_Challenge","1",0,0,"doTagsForEverybody");
	//RTB_registerPref("Tag Color 7","Challenge","$LevelTag[6]","int 0 8","Server_Challenge","7",0,0,"doTagsForEverybody");
	//RTB_registerPref("Tag Color 8","Challenge","$LevelTag[7]","int 0 8","Server_Challenge","8",0,0,"doTagsForEverybody");
}
//If they don't have any prefs that support RTB prefs
else{
	warn("RTB/Glass/oRBs not found. You should get those from the forums!");
	$ChallengeName = "_default";
	$EnableLevelTags = true;
	$LevelCount = 30;
	$KillOnEnterLiquid = 1;
}

$LevelTag[0] = "\c5"; //Pink
$LevelTag[1] = "\c4"; //Cyan
$LevelTag[2] = "\c2"; //Green
$LevelTag[3] = "\c3"; //Yellow
$LevelTag[4] = "\c6"; //White
$LevelTag[5] = "\c1"; //Blue
$LevelTag[6] = "\c7"; //Gray
$LevelTag[7] = "\c8"; //Black

//All of these are based on the challenge name, so...
$ChallengePath = "config/server/challenge/" @ $ChallengeName @ "/players.txt";
$ChallengeWin = "config/server/challenge/" @ $ChallengeName @ "/win.txt";
$UnlockedLevelsPath = "config/server/challenge/" @ $ChallengeName @ "/unlockedLevels/";
$Platformer::Challenge::SpeedrunFile = "config/server/challenge/" @ $ChallengeName @ "/platformerspeedrun.txt";

//////
// Callbacks
//////

//If the challenge gets switched
function onChangeInChallengeName(%oldpref,%newpref)
{
	warn("Change in Challenge Name detected! Resetting everybody...");
	
	//Save everything for everyone
	for(%i = 0; %i < ClientGroup.getCount();%i++)
	{
		%c = ClientGroup.getObject(%i);
		%c.saveChallengeVars();
		%c.saveUnlockedLevels();
	}
	
	//Change appropriate variables
	$ChallengePath = "config/server/challenge/" @ $ChallengeName @ "/players.txt";
	$ChallengeWin = "config/server/challenge/" @ $ChallengeName @ "/win.txt";
	$UnlockedLevelsPath = "config/server/challenge/" @ $ChallengeName @ "/unlockedLevels/";
	$Platformer::Challenge::SpeedrunFile = "config/server/challenge/" @ $ChallengeName @ "/platformerspeedrun.txt";
	
	//Load new shit
	for(%i = 0; %i < ClientGroup.getCount();%i++)
	{
		%c = ClientGroup.getObject(%i);
		%c.loadChallengeVars();
		%c.loadUnlockedLevels();
		%c.doTags();
		%c.instantRespawn();
	}
}

//Tags get disabled
function doTagsForEverybody(%oldpref,%newpref)
{
//	for(%i = 0; %i <= 7; %i++)
//	{
//		if($LevelTag[%i] == 0)
//			$LevelTag[%i] = "\c0";
//		else if($LevelTag[%i] == 1)
//			$LevelTag[%i] = "\c1";
//		else if($LevelTag[%i] == 2)
//			$LevelTag[%i] = "\c2";
//		else if($LevelTag[%i] == 3)
//			$LevelTag[%i] = "\c3";
//		else if($LevelTag[%i] == 4)
//			$LevelTag[%i] = "\c4";
//		else if($LevelTag[%i] == 5)
//			$LevelTag[%i] = "\c5";
//		else if($LevelTag[%i] == 6)
//			$LevelTag[%i] = "\c6";
//		else if($LevelTag[%i] == 7)
//			$LevelTag[%i] = "\c7";
//		else if($LevelTag[%i] == 8)
//			$LevelTag[%i] = "\c8";
//		else $LevelTag[%i] = "\c1";
//	}
	for(%i = 0; %i < ClientGroup.getCount();%i++)
	{
		%c = ClientGroup.getObject(%i);
		%c.doTags();
	}
}

//////
// Helper Functions
//////

//Updates tags for everybody
//e.g. [5] [Achoo]: test talking / [F] [Achoo]: I've won!
function GameConnection::doTags(%client)
{
	if(!$EnableLevelTags)
		%client.clanPrefix = %client.oldPref;
	else
		if(%client.level <= $LevelCount)
			%client.clanPrefix = "\c7[" @ $LevelTag[(mCeil(%client.level / 10) % 8) - 1] @ %client.level @ "\c7]" SPC %client.oldPref;
		else
			%client.clanPrefix = "\c7[" @ $LevelTag[(mCeil(%client.level / 10) % 8) - 1] @ "F\c7]" SPC %client.oldPref;
}

//Discovered by Eagle517 Dec 2014 that the time difference between /goto and the
//speedrun stopping varied for some reason. This is to make sure that dosn't happen
//by repeatedly shutting down speedruns over a half-second time frame.
function Player::speedrunchecker(%this,%num)
{
	if(isEventPending(%this.speedrunCheckTimer))
		cancel(%this.speedrunCheckTimer);
	
	if(%num < 10)
	{
		if(%this.isSpeedrunning)
		{
			%this.SpeedrunCancel();
			return;
		}
		%this.speedrunCheckTimer = %this.schedule(50,speedrunChecker,num+1);
	}
	else return;
}

//Completely cancel a speedrun for a player and reset associated variables.
function Player::SpeedrunCancel(%this)
{
	if(isEventPending(%this.speedrun))
		cancel(%this.speedrun);

	if(!%this.isSpeedrunning)
		return;
	
	%this.speedrunStart = "";
	%this.isSpeedrunning = false;
}

//////
// Events
//////

//Set their checkpoint to the stated brick (string).
//-> Client -> setCheckpoint ( string 200 100 )
function GameConnection::setCheckpoint(%client, %cp)
{
	%cp = ("_" @ %cp).getID();
	if(isObject(%cp))
	{
		%client.checkPointBrick = %cp;
		%client.checkPointBrickPos = %cp.getPosition();
	}
}

//Required at the end of every level.
//-> Client -> levelEnd ( int 0 9999 1 )
function GameConnection::levelEnd(%client, %level)
{
	//If the client's level is below or equal to this one, upgrade them. Else do nothing.
	if(%client.level <= %level)
	{
		messageClient(%client, '', "\c6Nice! You beat level\c3 " @ %level @ "\c6!");
		%client.level = %level + 1;
		%client.saveChallengeVars();
		%client.doTags();
		
		//If they've won, save them in the win file.
		if(%client.level > $LevelCount)
		{
			%file = new FileObject();
			%file.openForAppend($ChallengeWin);
			%file.writeLine(%client.name SPC "(" @ %client.bl_id @ ")");
			%file.close();
			%file.delete();
		}
	}
}

//Registration
registerOutputEvent(GameConnection, setCheckpoint, "string 200 100");
registerOutputEvent(GameConnection, levelEnd, "int 0 9999 1");

//////
// Client State Loading/Saving
//////

//Load variables
function GameConnection::loadChallengeVars(%client)
{
	//In case they aren't found in the file, set their level
	%client.level = 1;
	
	if(isFile($ChallengePath))
	{
		%file = new FileObject();
		%file.openForRead($ChallengePath);

		echo("_Reading file for " @ %client.name @ " (" @ %client.bl_id @ ")...");
		//Read the file
		while(!%file.isEOF())
		{
			%line = %file.readLine();
			//If it's the client's BL_ID on this line
			if(getField(%line, 0) == %client.bl_id)
			{
				//Format's in BL_ID TAB Name TAB Level, so grab the 3rd field (0, 1, 2)
				%client.level = getField(%line, 2);
				echo("_Found! " @ %line);
				break;
			}
		}
		
		//Cleanup
		%file.close();
		%file.delete();
	}
	
	//Tags
	%client.doTags();
}

//Saving to the file in $ChallengePath
function GameConnection::saveChallengeVars(%client)
{
	%file = new fileObject();
	if(isFile($ChallengePath))
	{
		//Warn
		warn("Writing file for" SPC %client.name @ "...");
		%store = new scriptObject();
		
		//Read and store all the lines except for the one with the client's BL_ID
		%file.openForRead($ChallengePath);
		%i = 0;
		while(!%file.isEOF())
		{
			%line = %file.readLine();
			%curClient = getField(%line, 0);
			if(%curClient $= %client.bl_id)
				%store.skipLine = %i;
			%store.line[%i] = %line;
			%i++;
		}
		%file.close();

		//Write all the previous lines except the client's
		%file.openForWrite($ChallengePath);
		for(%x = 0; %x < %i; %x++)
		{
			if(%store.skipLine !$= "" && %x == %store.skipLine)
				continue;
			%line = %store.line[%x];
			%file.writeLine(%line);
		}
		//Write the client's line
		%file.writeLine(%client.bl_id TAB %client.name TAB %client.level);
		
		//Cleanup
		%file.close();
		%store.delete();
	}
	else
	{
		//No file, so create one.
		%file.openForWrite($ChallengePath);
		%file.writeLine(%client.bl_id TAB %client.name TAB %client.level);
		%file.close();
	}
	
	//Cleanup
	%file.delete();
}

//////
// Package
//////

package challenge
{
	//////
	// Connection
	//////
	
	//Set old suffixes and prefixes, load level & et cetera
	//Called as soon as someone joins.
	function GameConnection::autoAdminCheck(%client)
	{
		%parent = parent::autoAdminCheck(%client);
		
		%client.oldPref = %client.clanPrefix;
		%client.oldSuff = %client.clanSuffix;
		%client.loadChallengeVars();
		
		//This is mainly here just in case things don't get set when they should.
		$Platformer::Challenge::SpeedrunFile = "config/server/challenge/" @ $ChallengeName @ "/platformerspeedrun.txt";
		
		return %parent;
	}
	
	//Sets a clients checkpoint.
	//Called when someone spawns for some reason.
	function GameConnection::onClientEnterGame(%client)
	{
		parent::onClientEnterGame(%client);
		
		%client.setCheckpoint("Level_" @ %client.level);
		%client.instantRespawn();
	}
	//Kill players on liquid
	function Armor::onEnterLiquid(%data, %obj, %coverage, %type)
	{
		Parent::onEnterLiquid(%data, %obj, %coverage, %type);
		if($KillOnEnterLiquid)
		{
			%obj.hasShotOnce = true;
			%obj.invulnerable = false;
			%obj.damage(%obj, %obj.getPosition(), 10000, $DamageType::Lava);
		}
	}
	
	//Save variables upon leaving.
	function GameConnection::onClientLeaveGame(%client)
	{
		%client.saveChallengeVars();
		parent::onClientLeaveGame(%client);
	}
	
	//////
	// Other
	//////
	
	//The problem with this is that there is another delay in the kill function it seems like
	//so i can't really do shit about this
	//Lowers the suicide prevention delay to a half-second.
	//function serverCMDsuicide(%client)
	//{
		//if(!$LessenSuicideDelay)
		//{
			//Parent::serverCMDsuicide(%client);
			//return;
		//}
		
		//else if(!isEventPending(%client.noSuicideDelay))
		//{
			//%client.noSuicideDelay = %client.schedule(500, lolYouCantSuicide);
			//%client.player.kill();
		//}
	//}
	
	//////
	// Server_GoTo Edits
	//////
	
	//Gets rid of the annoying messageClients at the end of this function.
	//Basically just ripped this out of Server_GoTo. Sorry jes00!
	function fxDTSBrick::levelUnlock(%brick,%num,%client)
	{
		if(!isObject(%client))
		{
			return;
		}

		if(!isNumber(%num) || %num < 0 || %num > 999999)
		{
			return;
		}

		if(strPos(%client.unlockedLevels, " " @ %num @ " ") != -1)
		{
			return;
		}

		if(!getWordCount(%client.unlockedLevels))
		{
			%client.unlockedLevels = " " @ %num @ " ";
		}

		else
		{
			%client.unlockedLevels = %client.unlockedLevels @ %num @ " ";
		}
	}
	
	//Allows for changes in where unlocked levels are stored
	//Basically just ripped these out of Server_GoTo. Sorry jes00!
	function gameConnection::saveUnlockedLevels(%client)
	{
		%bl_id = ($Server::LAN) ? getNumKeyID() : %client.bl_id;
		
		%file = new fileObject();
		%file.openForWrite($UnlockedLevelsPath @ %bl_id @ ".txt");
		
		%file.writeLine(%client.unlockedLevels);
		
		%file.close();
		%file.delete();
	}
	function gameConnection::loadUnlockedLevels(%client)
	{
		%bl_id = ($Server::LAN) ? getNumKeyID() : %client.bl_id;
		
		if(!isFile($UnlockedLevelsPath @ %bl_id @ ".txt"))
		{
			return;
		}
		
		%file = new FileObject();
		%file.openForRead($UnlockedLevelsPath @ %client.BL_ID @ ".txt");
		
		%client.unlockedLevels = %file.readLine();
		
		%file.close();
		%file.delete();
	}
	
	//Stop any speed run and set their checkpoint to the level they're going to.
	//Basically just ripped this out of Server_GoTo. Sorry jes00!
	function serverCmdGoTo(%client, %num)
	{
		if(!isObject(%client))
		{
			return;
		}

		if(!isObject(%client.player))
		{
			messageClient(%client,'',"\c0You must spawn before using this command!");

			return;
		}

		if(!isNumber(%num))
		{
			messageClient(%client,'',"\c0Error! Invalid number!");
	
			return;
		}

		%brick = getWord($Level[%num], getRandom(0, getWordCount($Level[%num]) - 1));

		if(!isObject(%brick) && %brick !$= "")
		{
			$Level[%num] = removeItemFromList($Level[%num], %brick);
			%client.unlockedLevels = removeItemFromList(%client.unlockedLevels, %brick);

			serverCmdGoTo(%client, %num);
			return;
		}

		if($Level[%num] $= "")
		{
			messageClient(%client,'',"\c0Error! Level does not exist!");

			if(!getWordCount(trim(%client.unlockedLevels)))
			{
				messageClient(%client,'',"\c0You haven't unlocked any levels.");

				return;
			}

			for(%i = 1; %i < getWordCount(%client.unlockedLevels); %i++)
			{
				%unlockedLevels = %unlockedLevels @ "\c3" SPC getWord(%client.unlockedLevels, %i) @ "\c6,";
			}

			%unlockedLevels = getSubStr(%unlockedLevels, 0, strLen(%unlockedLevels) - 1) @ "\c6.";
	
			messageClient(%client,'',"\c6Levels you've unlocked:" @ %unlockedLevels);

			return;
		}

		if(strPos(%client.unlockedLevels, " " @ %num @ " ") == -1)
		{
			messageClient(%client,'',"\c0You haven't unlocked that level yet!");

			if(!getWordCount(trim(%client.unlockedLevels)))
			{
				return;
			}

			for(%i = 1; %i < getWordCount(%client.unlockedLevels); %i++)
			{
				echo(getWord(%client.unlockedLevels, %i));

				%unlockedLevels = %unlockedLevels @ "\c3" SPC getWord(%client.unlockedLevels, %i) @ "\c6,";
			}

			%unlockedLevels = getSubStr(%unlockedLevels, 0, strLen(%unlockedLevels) - 1) @ "\c6.";

			messageClient(%client,'',"\c6Levels you've unlocked:" @ %unlockedLevels);

			return;
		}

		%client.player.transformTimer = %client.player.schedule(250,setTransform,%brick.getTransform());
		%client.player.speedrunCheckTimer = %client.player.schedule(50,speedrunchecker,0);
	
		%i = 1;
		%stronk = getWord(%client.unlockedLevels,%i);
		while(%stronk !$= "")
		{
			if(%stronk == %num) %client.setCheckpoint("Level_" @ %num);
			%stronk = getWord(%client.unlockedLevels,%i++);
		}
		
		%client.instantRespawn();
	}
	
	//////
	// Event_SpeedRun Edits
	//////
	
	//Only end the speedrun if it's the correct end point
	function Player::SpeedrunEnd(%this, %race, %record) //Original function by ottosparks
	{
		if(%race !$= %this.speedrunName)
			return;
	
		if(isEventPending(%this.speedrun))
			cancel(%this.speedrun);

		if(!%this.isSpeedrunning)
			return;

	
		if(isObject(%this.client))
		{	
			%time = $Sim::Time - %this.speedrunStart;
			%dtime = formatSeconds(%time, $Platformer::Challenge::SpeedrunTimeSep0, $Platformer::Challenge::SpeedrunTimeSep1);

			%race = (%this.speedrunName !$= "" ? %this.speedrunName : "Speedrun");

			%this.client.bottomPrint("<font:verdana:20><just:right>\c3" @ %race @ "\c6:<br>\c2" @ %dtime @ " ", 3, 1);

			if(%record && %race !$= "Speedrun" && %time < $SpeedrunRecords_[%race])
			{
				$SpeedrunRecords_[%race] = %time;
				$SpeedrunRecordHolders_[%race] = %this.client.getPlayerName();
				messageAll('', "<font:verdana bold:20>\c3" @ %this.client.getPlayerName() @ "\c6 set a new record for \c3" @ %race @ "\c6! \c2(" @ %dtime @ ")");
				speedrunWrite(%race);
			}
		}
		%this.speedrunStart = "";
		%this.isSpeedrunning = false;
	}
};
activatePackage(challenge);